***********************************************************************************************************;
***
*** Programme       : Programme de demonstration.sas
***
*** Auteur          : Patrice Bourdages
***
*** Date cration   : 2007-10-01
***
*** Objectif        : 
***
*** Commentaires    : 
***
*** Pralable(s)    : 
***
*** Entrants        : 
***
*** Extrants        : 
***
*** Macro(s)        : 
***
*** Rvisions       :   #   Qui   Quand     Description
***                  ----------------------------------------------------------------------------------
***                     0   PB  aaaa-mm-jj  Dtails sur le changement
***
***********************************************************************************************************;

dm editor "pgm off" editor continue;            /* ferme */

dm editor "dir work" continue;                  /* ouvre */

dm editor "listing on" editor;                  /* ouvre */
dm editor "listing off" editor;                 /* ferme */

dm editor "explorer 1" editor continue;         /* ouvre */
dm editor "explorer 1; end" editor continue;    /* ferme */

dm editor "odsresults" editor;                  /* ouvre */
dm editor "odsresults" cancel editor;           /* ferme */

dm log "color warning green reverse" continue;
dm log "color error orange reverse" continue;




data work.erreur;
	set bingo.dd;
run;









data work.Demo_1;
    x = 1;
    y = 2;
    z = sum(x,y);
run;
*dm editor "vt _last_" continue;











** Non document chez SAS **;
dm editor "postmessage 'Traitement termin !'" continue;




















data _null_;
    do Annee = 2000 to 2020;
        do Mois = 3 to 12 by 3;
            select (Mois);
                when (3) Jour = 31;
                when (6) Jour = 30;
                when (9) Jour = 30;
                when (12) Jour = 31;
            end;
            FinTrimestre = mdy(Mois, Jour, Annee);
            UneDate      = intnx("week.6", FinTrimestre, 0); * 1 = Dimanche, 7 = samedi *;
            put UneDate = weekdatx.;
        end;
    end;
run;










/*  INTNX('interval',start-from,increment<,'alignment'>)  */
/*
	Date Intervals  	Datetime Intervals  	Time Intervals
	DAY 			DTDAY 			HOUR
	WEEKDAY 		DTWEEKDAY 			MINUTE
	WEEK 			DTWEEK 			SECOND
	TENDAY 		DTTENDAY 	
	SEMIMONTH 		DTSEMIMONTH 	
	MONTH 		DTMONTH 	
	QTR 			DTQTR 	
	SEMIYEAR 		DTSEMIYEAR 	
	YEAR 			DTYEAR


'alignment'
    specifies one of these values:

    BEGINNING
        specifies that the returned date is aligned to the beginning of the interval.
        Alias: 	B

    MIDDLE
        specifies that the returned date is aligned to the midpoint of the interval.
        Alias: 	M

    END
        specifies that the returned date is aligned to the end of the interval.
        Alias: 	E

    Default: 	BEGINNING

*/


%let AnneeActuelle = 2008;

data work.age;
	format Une_Date
             Naissance yymmdd10.;

	Une_Date  = "02apr2008"d;
	Naissance = "31aug1963"d;

	A = INT((Une_date - Naissance) / 365.25);

	B = &AnneeActuelle. - YEAR(Naissance);

	C = FLOOR(YRDIF(Naissance, Une_Date, 'ACT/ACT'));

	D = INTCK("year", Naissance, Une_Date);

	E = FLOOR(INTCK("month", Naissance, Une_Date) / 12);

	F = FLOOR(INTCK("day", Naissance, Une_Date) / 365.25);

	G = INT((INTCK('month', Naissance, Une_Date) - (DAY(Naissance) > DAY(Une_Date))) / 12);

run;
dm editor "vt work.age" continue;














data work.a (index = (clef));
    clef     = 1;
    Quantite = 2;
run;

data work.b (index = (clef));
    clef       = 1;
    Quantite   = 3;
    EnCommande = 4;
run;

%macro Traite(QuelMsgLevel);
    options msglevel = &QuelMsgLevel;
    data work.c;
        merge work.a (in = a)
              work.b (in = b);
        by clef;
        if a and b;
    run;
%mend;

%traite(N);
%traite(I);











***********************************************************************************************************;
***                                            Fin du programme                                         ***;
***********************************************************************************************************;
